<?php 
/*
Plugin Name: X-Valid
Plugin URI: http://jamietalbot.com/wp-hacks/
Description: Attempts to create valid XHTML from arbitrary source.<br/>Licensed under the <a href="http://www.opensource.org/licenses/mit-license.php">MIT License</a>, Copyright &copy; 2004-2005 Jamie Talbot.
Version: 0.99
Author: Jamie Talbot
Author URI: http://jamietalbot.com/
*/ 

/*
X-Valid - Attempt to create valid XHTML from arbitrary source.
Copyright (c) 2004-2005 Jamie Talbot

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated
documentation files (the "Software"), to deal in the
Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to
do so, subject to the following conditions:

The above copyright notice and this permission notice shall
be included in all copies or substantial portions of the
Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

define ("XVALID_DIR", "wp-content/plugins/xvalid/");
define ("XVALID_CFG", "xvalid.cfg");
define ("XVALID_OUT", "xv_output.php");

if (is_plugin_page())
{
	$v = new XValidator();
	if (isset($_POST['action']) && $_POST['action'] == "update")
	{
		$o = fopen(ABSPATH . XVALID_DIR . XVALID_CFG, "w");
		fwrite($o, "Remove Invalid Tags: " . ($_POST['remove_invalid_tags'] ? "true" : "false") . "\n");
		fwrite($o, "Remove Invalid Comment Tags: " . ($_POST['strip_invalid_comment_tags'] ? "true" : "false") . "\n");
		fwrite($o, "Add Attributes: " . ($_POST['auto_add_attributes'] ? "true" : "false") . "\n");
		fwrite($o, "Remove Attributes: " . ($_POST['auto_remove_attributes'] ? "true" : "false") . "\n");
		fwrite($o, "Remove Empty Pairs: " . ($_POST['remove_empty_pairs'] ? "true" : "false") . "\n");
		fwrite($o, "Auto Wrap List Elements: " . ($_POST['wrap_list_elements'] ? "true" : "false") . "\n");
		fwrite($o, "Show Output: " . ($_POST['default_show_output'] ? "true" : "false") . "\n");
		fwrite($o, "Email Author: " . ($_POST['email_notification'] ? "true" : "false") . "\n");
		fwrite($o, "Parse Comments: " . ($_POST['comment_checking'] ? "true" : "false") . "\n");
		fwrite($o, "Convert Less Thans: " . ($_POST['convert_less_thans'] ? "true" : "false") . "\n");
		fwrite($o, "Check For Updates: " . ($_POST['update_check'] ? "true" : "false") . "\n");
		fwrite($o, "Doctype: " . $_POST['doctype'] . "\n");
		fclose($o);
	?>
	<div class="updated fade"><p>Options Updated</p></div>
	<?php
	}
	elseif (!file_exists(ABSPATH . XVALID_DIR . XVALID_CFG) || (isset($_POST['action']) && $_POST['action'] == "reset"))
	{
		$v->reset_options();
		
		if (isset($_POST['action']) && $_POST['action'] == "reset") ?><div class="updated"><p><strong>Options Reset</strong></p></div><?php
	}
	$v->get_options();
	
	?>

	<div class="wrap"> 
	<h2>X-Valid Options</h2>
	<p>
	
	X-Valid has a number of options you can configure, enabling a customisable amount
	of correction and feedback.
	</p>
	<p>
	X-Valid can automatically check and remove invalid or redundant tags.  Use the checkboxes below to configure how you
	want it to behave in the given situations.  Remember, <strong>X-Valid validates against the doctype you select below.</strong>
	If you choose the XHTML 1.0 Strict Doctype and 'Automatically Remove Invalid Tags', tags that are valid against the
	<em>Transitional</em> doctype could be automatically deleted! 
	</p>
	<p>
	<em>Therefore, it's recommended that you leave auto-removal of unknown tags and attributes disabled if you don't know
	which tags are valid for your chosen doctype</em>.  In general the Transitional doctype is a safer choice if you are unsure.
	</p>
	
	<form name="xvoptionsform" method="post"> 
	<input type="hidden" name="action" value="update" /> 


  <div id="advancedstuff" class="dbx-group">
	<fieldset class="dbx-box" <?php if (!$v->doctype_count) { ?>style="background: red; border-color: black" <?php } ?>>
	<h3 class="dbx-handle"><?php if (!$v->doctype_count) { ?>style="background: red; border: 1px solid black; -moz-border-radius: 5px;" <?php } ?>Validating Doctype</h3>
  <div class="dbx-content">
	<ul>
	<?php
	$doc_count = 0;
	if (!$v->doctype_count) { ?><li style="list-style: none; text-align: center"><strong><em>X-Valid couldn't find any doctypes to validate against.  Please add valid doctype files to xvalid's folder or reinstall the plugin<?php if (file_exists(ABSPATH . "wp-plugin-mgr.php")) { ?> using the <a href="<?php echo get_settings('home') ?>/wp-plugin-mgr.php">Plugins Manager</a><?php } ?>.</em></strong></li><?php } 
	else 
	{ 
		foreach ($v->doctypes as $internal => $doc_desc)
		{		
			$doc_count++;
		?>
		<li>
		<label for="<?php echo "doctype_$doc_count" ?>"> 
		<input name="doctype" type="radio" id="<?php echo "doctype_$doc_count" ?>" value="<?php echo $internal ?>" <?php if ($internal == $v->options['doctype']) echo " checked=\"checked\""; ?>/>
		<?php echo $doc_desc ?></label>
		</li>
		<?php
		}
	}
	?>
	</ul>
	</div>
	</fieldset>
	
  <fieldset class="dbx-box">
  <h3 class="dbx-handle">Auto-Correction</h3>
  <div class="dbx-content">
	<ul> 
	<li> 
	<label for="remove_invalid_tags"> 
	<input name="remove_invalid_tags" type="checkbox" id="remove_invalid_tags" value="true"<?php if ("true" == $v->options['auto_inv_tags']) echo " checked=\"checked\""; ?> /> 
	Automatically remove invalid tags (Not recommended).</label> 
	</li> 
	<li> 
	<label for="strip_invalid_comment_tags"> 
	<input name="strip_invalid_comment_tags" type="checkbox" id="strip_invalid_comment_tags" value="true"<?php if ("true" == $v->options['auto_inv_comm']) echo " checked=\"checked\""; ?> /> 
	Automatically remove unavailable tags from post comments.</label>
	</li> 
	<li> 
	<label for="auto_add_attributes"> 
	<input name="auto_add_attributes" type="checkbox" id="auto_add_attributes" value="true"<?php if ("true" == $v->options['auto_add_atts']) echo " checked=\"checked\""; ?> /> 
	Automatically add required attributes.</label> 
	</li>
	<li> 
	<label for="auto_remove_attributes"> 
	<input name="auto_remove_attributes" type="checkbox" id="auto_remove_attributes" value="true"<?php if ("true" == $v->options['auto_remove_atts']) echo " checked=\"checked\""; ?> /> 
	Automatically remove invalid attributes (Not recommended).</label> 
	</li>
	<li> 
	<label for="remove_empty_pairs"> 
	<input name="remove_empty_pairs" type="checkbox" id="remove_empty_pairs" value="true"<?php if ("true" == $v->options['auto_remove_empty']) echo " checked=\"checked\""; ?> /> 
	Automatically remove tag pairs with no content.</label> 
	</li> 
	<li> 
	<label for="wrap_list_elements"> 
	<input name="wrap_list_elements" type="checkbox" id="wrap_list_elements" value="true"<?php if ("true" == $v->options['auto_wrap_lists']) echo " checked=\"checked\""; ?> /> 
	Automatically wrap list elements in &lt;li&gt; tags if required.</label> 
	</li> 
	<li> 
	<label for="convert_less_thans"> 
	<input name="convert_less_thans" type="checkbox" id="convert_less_thans" value="true"<?php if ("true" ==  $v->options['convert_less_thans']) echo " checked=\"checked\""; ?> /> 
	Automatically convert less thans (&lt;) to &amp;lt; entities.</label> 
	</li> 
	</ul>
	</div>
	</fieldset>
	
  <fieldset class="dbx-box">
  <h3 class="dbx-handle">Feedback</h3>
  <div class="dbx-content">
	<ul> 
	<li> 
	<label for="default_show_output"> 
	<input name="default_show_output" type="checkbox" id="default_show_output" value="true"<?php if ("true" == $v->options['show_output']) echo " checked=\"checked\""; ?> /> 
	Show parse results by default (May be overridden for individual articles).</label> 
	</li> 
	<li> 
	<label for="email_notification"> 
	<input name="email_notification" type="checkbox" id="email_notification" value="true"<?php if ("true" ==  $v->options['email_author']) echo " checked=\"checked\""; ?> /> 
	Email post author when a badly marked up comment is added to their post.</label> 
	</li> 
	</ul>
	</div> 
	</fieldset>
	
  <fieldset class="dbx-box">
  <h3 class="dbx-handle">Miscellaneous</h3>
  <div class="dbx-content">
	<ul> 
	<li> 
	<label for="comment_checking"> 
	<input name="comment_checking" type="checkbox" id="comment_checking" value="true"<?php if ("true" == $v->options['parse_comments']) echo " checked=\"checked\""; ?> /> 
	Parse comments.</label> 
	</li>
	<li> 
	<label for="update_check"> 
	<input name="update_check" type="checkbox" id="update_check" value="true"<?php if ("true" == $v->options['update_check']) echo " checked=\"checked\""; ?> /> 
	Automatically check for updates to X-Valid on this page or when feedback is generated.</label> 
	</li>
	</ul>
	</div> 
	</fieldset>
	
	<fieldset class="dbx-box" style="float: left; width: 255px;">
	<h3 class="dbx-handle">X-Valid <?php echo $v->version ?></h3> 
  <div class="dbx-content" style="padding-left: 3px">
	Copyright &copy; 2004-2005, <a href="http://jamietalbot.com/">Jamie Talbot</a><br />
	Licensed under the <a href="http://www.opensource.org/licenses/mit-license.php">MIT License</a>. 
	</div>
	</fieldset>

	<?php 
	if (("true" == $v->options['update_check']) && ($version = file_get_contents("http://jamietalbot.com/wp-hacks/xvalid/version-" . substr($wp_version, 0, 3) . ".txt")) && ($version > $v->version)) { ?>

	<fieldset class="dbx-box" style="float: left; margin-left: 0.5em; width: 255px;">
	<h3 class="dbx-handle">Update Available</h3> 
  <div class="dbx-content" style="padding-left: 3px">
	Version <?php echo $version ?> now available!<br />
	Get it <a href="http://jamietalbot.com/wp-hacks/">here</a><?php if (file_exists(ABSPATH . "wp-plugin-mgr.php")) { ?> or using the <a href="<?php echo get_settings('home') ?>/wp-plugin-mgr.php">Plugins Manager</a><?php } ?>.
  </div>
	</fieldset>
	</div>


	<?php } ?>
	
	<p class="submit"> 
	<input type="submit" name="Submit" value="Update Options &raquo;" />
	</p> 
	</form>	
	
	<form name="xvresetform" method="post"> 
	<input type="hidden" name="action" value="reset" /> 
	<p class="submit"> 
	<input type="submit" name="Defaults" id="deletepost" value="Reset To Defaults &raquo;" />
	</p> 
	</form>

	</div>
<?php
}
else
{
	remove_action('comment-text','balanceTags');
	remove_action('edit_post','balanceTags');
	remove_action('publish_post','balanceTags');
  add_action('edit_form_advanced', 'xvalid_admin');
  add_action('edit_page_form', 'xvalid_admin');
	add_action('publish_post', 'xvalid_post', 8);
	add_action('comment_post', 'xvalid_comment', 8);
	add_action('edit_comment', 'xvalid_comment', 8);
	
	class XValidator
	{
		var $tags, $unfixed, $el, $att, $commatt, $automatic, $version, $names, $ids, $verbose, $comment, $options;
		
		function XValidator($verbose = false, $post_id = 0, $auto = false, $comment = 0)
		{
			$this->version = "0.99";
			$this->tags = array();
			$this->names = array();
			$this->ids = array();
			$this->unfixed = array();
			$this->log = array();
			$this->options = array();
			$this->verbose = $verbose;
			$this->automatic = $auto;
			$this->comment = $comment;
			$this->post_id = $post_id;

			$this->build_doctype_list();
			$this->get_options();		
		}

		function build_doctype_list()
		{
			if($handle = opendir(ABSPATH . XVALID_DIR))
			{ 
				// Loop through all files
				while(false !== ($file = readdir($handle)))
				{
					// Build an array of php files containing a doctype header.
					if(preg_match("/\.php/", $file))
					{
						$dt = implode('', file(ABSPATH . XVALID_DIR . "$file"));
						if (preg_match("|Doctype:(.*)|i", $dt, $temp)) $this->doctypes[substr($file, 0, -4)] = trim($temp[1]);
					}
				}
			}
			$this->doctype_count = count($this->doctypes);
		}
	
		function initialise_tags($doctype = "xhtml-strict-10")
		{
			return require_once (ABSPATH . XVALID_DIR . "$doctype.php");		
		}
	
		function get_options()
		{
			if (!file_exists(ABSPATH . XVALID_DIR . XVALID_CFG)) $this->reset_options();
			
			// Now check again, in case write access is denied.
			if (file_exists(ABSPATH . XVALID_DIR . XVALID_CFG))		
			{
				$xv_options = implode('', file(ABSPATH . XVALID_DIR . XVALID_CFG));
				preg_match("|Remove Invalid Tags:(.*)|i", $xv_options, $temp);
				$this->options['auto_inv_tags'] = trim($temp[1]);
				preg_match("|Remove Invalid Comment Tags:(.*)|i", $xv_options, $temp);
				$this->options['auto_inv_comm'] = trim($temp[1]);			
				preg_match("|Add Attributes:(.*)|i", $xv_options, $temp);
				$this->options['auto_add_atts'] = trim($temp[1]);	
				preg_match("|Remove Attributes:(.*)|i", $xv_options, $temp);
				$this->options['auto_remove_atts'] = trim($temp[1]);	
				preg_match("|Remove Empty Pairs:(.*)|i", $xv_options, $temp);
				$this->options['auto_remove_empty'] = trim($temp[1]);
				preg_match("|Auto Wrap List Elements:(.*)|i", $xv_options, $temp);
				$this->options['auto_wrap_lists'] = trim($temp[1]);
				preg_match("|Email Author:(.*)|i", $xv_options, $temp);
				$this->options['email_author'] = trim($temp[1]);
				preg_match("|Parse Comments:(.*)|i", $xv_options, $temp);
				$this->options['parse_comments'] = trim($temp[1]);
				preg_match("|Convert Less Thans:(.*)|i", $xv_options, $temp);
				$this->options['convert_less_thans'] = trim($temp[1]);
				preg_match("|Check For Updates:(.*)|i", $xv_options, $temp);
				$this->options['update_check'] = trim($temp[1]);
				preg_match("|Show Output:(.*)|i", $xv_options, $temp);
				$this->options['show_output'] = trim($temp[1]);
				preg_match("|Doctype:(.*)|i", $xv_options, $temp);
				$this->options['doctype'] = trim($temp[1]);		
			}
		}
		
		function reset_options()
		{
			// Rebuild default config if it's not there.
			$o = fopen(ABSPATH . XVALID_DIR . XVALID_CFG, "w");
			fwrite($o, "Doctype: xhtml-transitional-10\n");
			fwrite($o, "Remove Invalid Tags: false\n");
			fwrite($o, "Remove Invalid Comment Tags: true\n");
			fwrite($o, "Add Attributes: false\n");
			fwrite($o, "Remove Attributes: false\n");
			fwrite($o, "Remove Empty Pairs: true\n");
			fwrite($o, "Auto Wrap List Elements: true\n");
			fwrite($o, "Show Output: false\n");
			fwrite($o, "Email Author: true\n");
			fwrite($o, "Parse Comments: true\n");
			fwrite($o, "Convert Less Thans: true\n");
			fwrite($o, "Check For Updates: false\n");
			fclose($o);		
		}
			
		function is_empty_attribute($tag, $att)
		{
			return in_array("@" . $att, $this->att[$tag]);
		}

		function is_valid_attribute($tag, $att)
		{
			$dep = "*" . $att;
			$req = "+" . $att;
			$emp = "@" . $att;
			if (!in_array($att, $this->att[$tag]) && !in_array($req, $this->att[$tag]) && !in_array($emp, $this->att[$tag]) && !in_array($dep, $this->att[$tag]))
			{
				if (in_array("core", $this->att[$tag]) && (in_array($att, $this->att['core']) || in_array($req, $this->att['core']) || in_array($dep, $this->att['core']) || in_array($emp, $this->att['core']))) return true;
				if (in_array("lang", $this->att[$tag]) && (in_array($att, $this->att['lang']) || in_array($req, $this->att['lang']) || in_array($dep, $this->att['lang']) || in_array($emp, $this->att['lang']))) return true;
				if (in_array("keyb", $this->att[$tag]) && (in_array($att, $this->att['keyb']) || in_array($req, $this->att['keyb']) || in_array($dep, $this->att['keyb']) || in_array($emp, $this->att['keyb']))) return true;
				if (in_array("window", $this->att[$tag]) && (in_array($att, $this->att['window']) || in_array($req, $this->att['window']) || in_array($dep, $this->att['window']) || in_array($emp, $this->att['window']))) return true;
				if (in_array("formevts", $this->att[$tag]) && (in_array($att, $this->att['formevts']) || in_array($req, $this->att['formevts']) || in_array($dep, $this->att['formevts']) || in_array($emp, $this->att['formevts']))) return true;
				if (in_array("events", $this->att[$tag]) && (in_array($att, $this->att['events']) || in_array($req, $this->att['events']) || in_array($dep, $this->att['events']) || in_array($emp, $this->att['events']))) return true;
				if (in_array("standard", $this->att[$tag]))
				{
					if (in_array($att, $this->att['core']) || in_array($req, $this->att['core']) || in_array($dep, $this->att['core']) || in_array($emp, $this->att['core'])) return true;
					if (in_array($att, $this->att['lang']) || in_array($req, $this->att['lang']) || in_array($dep, $this->att['lang']) || in_array($emp, $this->att['lang'])) return true;
					if (in_array($att, $this->att['keyb']) || in_array($req, $this->att['keyb']) || in_array($dep, $this->att['keyb']) || in_array($emp, $this->att['keyb'])) return true;
				}
			}
			else return true;
			return false;
		}
		
		function check_attributes($tag, $attributes)
		{
			$parsed = array();
			$attributes = trim($attributes);
			$original = $attributes;
					
			if ($this->comment && !in_array($tag, $this->el['comments']))
			{
				if ("false" == trim($this->options['auto_inv_comm'])) $this->unfixed[] = "&lt;$tag&gt; is not a valid tag inside a comment, so I'm not altering its attributes.";
				return "<$tag $original>";		
			}
			
			if ((!isset($this->att[$tag])) && (!in_array($tag, $this->el['empty'])))
			{
				if ("true" != trim($this->options['auto_inv_tags'])) $this->unfixed[] = "&lt;$tag&gt; is not a valid XHTML tag, so I'm not altering its attributes.";
				return "<$tag $original>";
			}
	
			if ("/" == $attributes[strlen($attributes) - 1]) 
			{
				$attributes = substr($attributes, 0, -1);
				$e = true;
			}
			else $e = false;
			
			$mode = 'att';
			while (true)
			{
				// Trim the attribute string and finish if there's nothing left.
				if ("" == ($attributes = trim($attributes)))
				{
					if (('eq' == $mode) || ('val' == $mode))
					{
						// We were looking for an equals but we reached the end of the string.
						// If the last attribute is a valid empty attribute store it, otherwise ignore it.
						if ($this->is_empty_attribute($tag, $att)) $parsed[$att] = "$att";
						elseif ($this->is_valid_attribute($tag, $att)) $parsed[$att] = "";	
						elseif ("true" != trim($this->options['auto_remove_atts']))
						{
							// Don't remove it unless we are automatically removing attributes.
							$this->unfixed[] = "&lt;$tag&gt; doesn't allow an empty '$att' attribute.";
							$parsed[$att] = "$att";
						}
					}
					break;
				}
		
				switch($mode)
				{
					// Looking for an attribute now.
					case 'att':
			
						// Whitespace marks the end of the next tag attribute.
						if (false === ($whitespace = strpos($attributes, " "))) $whitespace = strlen($attributes);	
						if (false === ($equals = strpos(substr($attributes, 0, $whitespace), "="))) $equals = $whitespace;
						
						$att = trim(substr($attributes, 0, $equals));
						$attributes = substr($attributes, $equals);	
						$mode = 'eq';
						continue(2);
						
					// Looking for an equals sign.
					case 'eq':

						if ("=" == $attributes[0])
						{
							// All is good, found an equals sign next as expected.  Next, look for a value.
							$mode = 'val';
							$attributes = substr($attributes, 1);					
							continue(2);				
						}
						else
						{
							// There was no equals sign.  If the previous keyword isn't an empty attribute ignore it.				
							if ($this->is_empty_attribute($tag, $att)) $parsed[$att] = "$att";
							elseif ($this->is_valid_attribute($tag, $att)) $parsed[$att] = "";
							elseif ("true" != trim($this->options['auto_remove_atts']))
							{
								// Don't remove it unless we are automatically removing attributes.
								$this->unfixed[] = "&lt;$tag&gt; doesn't allow an empty '$att' attribute.";
								$parsed[$att] = "$att";
							}
							// Now, look for the next attribute.
							$mode = 'att';
							continue(2);
						}
						
					case 'val':
					
						if (("'" == $attributes[0]) || ('"' == $attributes[0]))
						{
							$mode = 'val';
							$attributes = substr($attributes, 1);					
							continue(2);					
						}
	
						if (false === ($equals = strpos($attributes, "=")))
						{
							// There are no equals signs in the rest of the string.
							// Loop backwards for the last word that is not an empty attribute.
							if (false === ($token_start = strrpos($attributes, " "))) 
							{
								$token_start = strlen($attributes);
								$word = rtrim(substr($attributes, 0, $token_start));						
							}
							else 
							{
								$token_intermediate = $token_start + 1;
								$word = rtrim(substr($attributes, $token_intermediate));
								$token_start = strlen($attributes);
							}
						}
						else
						{						
							// There is an equals sign, so loop backwards from the penultimate word before = for the last
							// non-empty attribute word.
							if (false === ($whitespace = strrpos(rtrim(substr($attributes, 0, $equals - 1)), " ")))
							{
								// An attribute with a blank value can also look like this.
								// First check that the value doesn't look like keyword=something.
								$val = substr($attributes, 0, $equals);
								if ($this->is_valid_attribute($tag, $val))
								{
									// This just looks like a value, but it's actually a new attribute after an empty one.
									$parsed[$att] = "";
									$this->unfixed[] = "X-Valid interpreted the '$att' attribute of the &lt;$tag&gt; as being empty, followed by a '$val' attribute.";
									$mode = 'att';
									continue(2);
								}
							
								// There are no spaces before the equals sign, so it's probably an href or similar.
								// Look for the next valid equals sign.
								while (false !== $equals)
								{
									$equals = strpos($attributes, "=", $equals + 1);
									if (false !== ($token_start = strrpos(rtrim(substr($attributes, 0, $equals - 1)), " "))) break;								
								}
								// This is the last attribute value in the string, with lots of equals signs.
								if (false === $token_start) $token_start = strlen($attributes);
							}
							else
							{
								// $whitespace holds the point which is just before the word before =.
								if (false === ($token_start = (strrpos(rtrim(substr($attributes, 0, $equals)), " ")))) $token_start = $whitespace;
								else $token_start++;
							}
							$word = rtrim(substr($attributes, 0, $token_start));						
							$token_intermediate = $token_start;
						}
						if ("'" == $word[strlen($word) - 1] || '"' == $word[strlen($word) - 1]) $word = substr($word, 0, -1);
						if (false !== strrpos($word, " ")) $word = substr($word, strrpos($word, " ") + 1);						
						
						while ($this->is_empty_attribute($tag, $word))
						{							
							$token_start = $token_intermediate;
							$token_finish = $token_intermediate - 1;

							if (false === ($token_intermediate = strrpos(rtrim(substr($attributes, 0, $token_finish)), " "))) $token_intermediate = 0;
							else $token_intermediate++;

							$word = substr($attributes, $token_intermediate, $token_finish - $token_intermediate);
							if ((" " == $word) || ("" == $word))
							{
								// By coincidence, all of the words are valid empty keywords.
								// Previous tag was almost certainly an empty one, but throw a caveat just in case.	
								$parsed[$att] = "";
								
								// Whitespace marks the end of the next attribute value.
								$whitespace = strpos($attributes, " ");
		
								// val holds the current attribute.
								$val = trim(substr($attributes, 0, $whitespace));
								if ("'" == $val[strlen($val) - 1] || '"' == $val[strlen($val) - 1]) $val = substr($val, 0, -1);
								$this->unfixed[] = "X-Valid interpreted the '$att' attribute of the &lt;$tag&gt; as being empty, followed by an empty '$val' attribute.";
								
								// Look for another attribute (even though we know they're all empty from now on).
								$mode = 'att';
								continue(3);
							}
						}
							
						// $token_start now holds the point at which empty attributes begin, so close the value here.
						$val = rtrim(substr($attributes, 0, $token_start));
						if ("'" == $val[strlen($val) - 1] || '"' == $val[strlen($val) - 1]) $val = substr($val, 0, -1);
						$parsed[$att] = $val;
							
						// Move the parse token past the last word and look for another attribute.
						$attributes = substr($attributes, $token_start);
						$mode = 'att';
						continue(2);						
						
				}
			}

			// Do special entity replacements and remove empty atts. (Stolen from WP's own!)
			// Also lowercase all the attributes.
			foreach ($parsed as $a => $v) 
			{
			  $a = strtolower($a);
				if (!$a) unset($parsed[$a]);
				else
				{
					$v = preg_replace('/&([^#])(?![a-z12]{1,8};)/', '&#038;$1', $v);
					$v = str_replace("'", '&#039;', $v);
					$parsed[$a] = str_replace('"', "&quot;", $v);
				}
			}

			// We now hopefully have a string parsed into attributes + values.			

			// First, check that all required tags are there...
			foreach ($this->att[$tag] as $required)
			{
				if ("+" != $required[0]) continue;
				$required = substr($required, 1);
				
				if (!isset($parsed[$required]))
				{
					if ("true" != trim($this->options['auto_add_atts'])) $this->unfixed[] = "&lt;$tag&gt; requires a '$required' attribute, but you have not included one.";
					else $parsed[$required] = "";
				}
			}		
			
			// Now check that all the attributes are valid in a comment, if necessary.
			if ($this->comment)
			{
				foreach ($parsed as $att => $val)
				{
					if (in_array($att, $this->commatt[$tag])) continue;
								
					if ("true" != trim($this->options['auto_inv_comm'])) $this->unfixed[] = "&lt;$att&gt; is not a valid attribute for a &lt;$tag&gt; tag in a comment.";
					else unset($parsed[$att]);
				}
			}
	
			// Now check that all the specified attributes are allowed in the given tag.
			foreach ($parsed as $att => $val) 
			{
				if (!$this->is_valid_attribute($tag, $att))
				{
					if ("true" != trim($this->options['auto_remove_atts'])) $this->unfixed[] = "&lt;$tag&gt; doesn't allow a '$att' attribute.";
					else unset($parsed[$att]);				
				}
			}
			
			$output = "<$tag";
			foreach ($parsed as $att => $val) $output .= " $att=\"$val\"";
			if ($e) $output .= " /";
			$output .= ">";
			
			return $output;
		}
		 
		function check_validity($newtag)
		{
			if (!isset($this->el[$newtag]) && !in_array($newtag, $this->el['empty']))
			{
				if ("true" != trim($this->options['auto_inv_tags']))
				{
					$this->unfixed[] = "&lt;$newtag&gt; is not a valid XHTML tag, but I didn't remove it because it might be a typo!";
					return -1;
				}
				else return -5;
			}
	
			$x = count($this->tags);
			$rv = -1;
			$valid = false;
	
			while (!$valid)
			{
				if ($x == 0) break;
				$tag = $this->tags[$x - 1];
	
				// Don't check against an invalid tag.
				if (isset($this->el[$tag]))
				{
					// Check for specific exclusions.
					if (!in_array("-$newtag", $this->el[$tag]))
					{
						// Check for specific allowed.
						if (!(in_array($newtag, $this->el[$tag])))
						{
							if ($newtag == $tag && -1 != $rv)
							{
								$rv--;
								$valid = true;
							}
	
							// Check for inline.
							if (!$valid && (in_array("inline", $this->el[$tag]) || in_array("flow", $this->el[$tag])))
							{
								if (in_array($newtag, $this->el['inline']) === false) $valid = false;
								else $valid = true;
							}
	
							// Check for block.
							if (!$valid && (in_array("block", $this->el[$tag]) || in_array("flow", $this->el[$tag])))
							{
								if (in_array($newtag, $this->el['block']) === false) $valid = false;
								else $valid = true;
							}
						}
						else $valid = true;
					}
					else $valid = false;
				}
				else
				{
					// Don't check against invalid tags.
					$x--;
					continue;
				}
				if ($valid) break;
				$rv = $x;
				$x--;
			}
	
			if ($rv != -1)
			{
				if (in_array($newtag, $this->el['empty'])) 
				{
					if ("true" != trim($this->options['auto_inv_tags'])) return -5;
					else $this->unfixed[] = "The empty tag &lt;$newtag&gt; cannot be inside a &lt;" . $this->tags[$x] . "&gt; tag.<br />";
				}
				return $rv;
			}
	
			// Tag is valid for the most recent child.  So, check for specific exclusions up the tree.
			$x--;
			for ($x; $x > 0; $x--)
			{
				$tag = $this->tags[$x - 1];
	
				// Check for specific exclusions.
				if (isset($this->el[$tag]) && in_array("-$newtag", $this->el[$tag]))
				{
					if (in_array($newtag, $this->el['empty'])) $this->unfixed[] = "The empty tag &lt;$newtag&gt; cannot be inside a &lt;" . $this->tags[$x - 1] . "&gt; tag.<br />";
					return $x;
				}
			}
			return -1;
		}
		
		function print_tree($input)
		{
			$indent = 0;
	
			// Compress whitespace.
			$input = str_replace(array("\n", "\r", "\t"), " ", $input);
			while (true)
			{				
				// Copy all text up to the beginning of the next tag.		
				if (false === ($start = strpos($input, '<'))) break; 
				if (false === ($end = strpos($input, '>'))) break;
				$less_than = strrpos(substr($input, 0, $end), '<');
				
				if (($less_than !== false) && ($less_than != $start)) $temp = substr($input, 0, $less_than);
				else $temp = substr($input, 0, $start);
	
				if ($temp)
				{
					$length = strlen($temp);
					while (strlen($temp) > (60 - (2 * ($indent + 1))))
					{
						if (false === ($breaker = strrpos(substr($temp, 0, (60 - (2 * ($indent + 1)))), " "))) 
						{
							$broken = true;
							$breaker = (60 - (2 * ($indent + 1)));
						}
						$output .= "\n" . str_repeat("  ", $indent + 1) . substr($temp, 0, $breaker);
						if ($broken) 
						{
							$temp = "-" . substr($temp, $breaker);
							$broken = false;
						}
						else $temp = substr($temp, $breaker + 1);
					}
					$output .= "\n" . str_repeat("  ", $indent + 1) . $temp;
					$input = substr($input, $length);
				}
				
				// Go to the beginning of the next tag			
				if (false === ($start = strpos($input, '<'))) break;
				if (false === ($end = strpos($input, '>'))) break;
		
				if (" " == $input[1]) $output .= substr($input, 0, $end + 1);
				elseif ("!" == $input[1]) $output .= "\n" . str_repeat(" ", (60 - $end) / 2) . substr($input, 0, $end + 1);
				elseif ("/" == $input[1]) 
				{
					$output .= "\n" . str_repeat("  ", $indent) . substr($input, 0, $end + 1);
					if (--$indent < 0) $indent = 0;
				}
				else 
				{
					$indent++;
					$output .= "\n" . str_repeat("  ", $indent) . substr($input, 0, $end + 1);
				}
	
				if ("/" == $input[$end - 1]) $indent--;
				$input = substr($input, $end + 1);
			}
	
			while (strlen($input) > (60 - (2 * ($indent + 1))))
			{
				if (false === ($breaker = strrpos(substr($input, 0, (60 - (2 * ($indent + 1)))), " "))) 
				{
					$broken = true;
					$breaker = (60 - (2 * ($indent + 1)));
				}
				$output .= "\n" . str_repeat("  ", $indent + 1) . substr($input, 0, $breaker);
				if ($broken) 
				{
					$input = "-" . substr($input, $breaker);
					$broken = false;
				}
				else $input = substr($input, $breaker + 1);
			}
			$output .= "\n" . str_repeat("  ", $indent + 1) . $input;
	
			// Try to save the situation if the text has unbalanced quotes.		
			if (1 == (substr_count($output, "\"") % 2)) $output .= "\"\n</xmp>The input text had unbalanced quotes, so the above layout is\nalmost certainly borked.  Sorry, can't do much about that.\nThis last double quote was added by the printer in an attempt\nto rescue the situation so that at least the rest of the\nfeedback will look ok.<xmp>";
	
			return $output;
		}
		
		function remove_empty_tags($unparsed)
		{
			$changes = 0;
			$output = "";
			$current = "";
			$buffer = "";
	
			while (true)
			{
				$i++;
				if ($i > 1000) break;
	
				if (!$buffer) $output .= $current;
				else
				{
					$buffer_tag = substr($current, 1, strpos($current,">") - 1);
	
					$nl = strpos($buffer_tag, 13);
					if ($nl === false) $nl = 1000;
					$sp = strpos($buffer_tag, " ");
					if ($sp === false) $sp = 999;
	
					if ($nl < $sp) $buffer_tag = trim(str_replace(strchr($buffer_tag, 13), "", $buffer_tag));
					else $buffer_tag = trim(str_replace(strchr($buffer_tag, " "), "", $buffer_tag));
	
					if (!$buffer_tag || (strpos($unparsed, "</$buffer_tag>") != 0))
					{
						$output .= $buffer;
						$buffer = "";
					}
					else
					{
						$unparsed = substr($unparsed, strpos($unparsed,">") + 1);
						$changes++;
					}
				}
				// Copy in non-tag text.
				$temp = substr($unparsed, 0, strpos($unparsed,"<"));
				if ($temp)
				{
					$output .= $temp;
					$unparsed = substr($unparsed, strlen($temp));
				}

				if (false === strpos($unparsed, '<')) break;
				if (!($current = substr($unparsed, strpos($unparsed, '<'), strpos($unparsed, '>') + 1))) break;
	
				$tag = substr($current, 1, strpos($current,">") - 1);
	
				if ((substr($tag, -1) != "/") && ("!--" != substr($tag, 0, 3)) && ("/" != substr($tag, 0, 1)) && (" " != substr($tag, 0, 1)) && (strrpos($tag, "<") === false)) $buffer = $current;
				else $buffer = "";
				$unparsed = substr($unparsed, strpos($unparsed,">") + 1);
			}
			$output .= $unparsed;
			if ($changes) $output = $this->remove_empty_tags($output);
			return $output;
		}

		function validate($unparsed)
		{
			global $wp_version;
			$i = 0;
			$parsed = "";
			$current = "";
			$old_unparsed = $unparsed;
			$processed = false;
			$less_than = false;

			if ($this->comment && "false" == trim($this->options['parse_comments'])) return $unparsed;
			$this->initialise_tags($this->options['doctype']);

			while (true)
			{
				$i++;
				if ($i > 500) die ("Infinite Loop Main");

				// Copy in the last tag parsed if it wasn't previously processed.
				if (!$processed) $parsed .= $current;
				else $processed = false;

				// Copy all text up to the beginning of the next tag.
				$temp = substr($unparsed, 0, strpos($unparsed,"<"));

				if ($temp)
				{	
					$length = strlen($temp);
					$temp = str_replace(">", "&gt;", $temp);
					if ($less_than) 
					{
						if (" " != $temp[0]) $parsed .= " ";
						$less_than = false;
					}
					
					if (($this->tags[count($this->tags) - 1] == "ul") || ($this->tags[count($this->tags) - 1] == "ol"))
					{
						if ("" != trim($temp))
						{
							// Can't have naked text in a list.
							if ("false" != trim($this->options['auto_wrap_lists']))
							{
								$parsed .= "<li>";
								array_push($this->tags, "li");
							}
							else $this->unfixed[] = "Only list element &lt;li&gt; tags may be inside a list, but naked text has been found.";
						}
					}
					
					$parsed .= $temp;
					$unparsed = substr($unparsed, $length);
				}
				elseif ($less_than) $less_than = false;

				// Go to the beginning of the next tag
				if (false === strpos($unparsed, '<')) break;
				if (!($current = substr($unparsed, strpos($unparsed, '<'), strpos($unparsed, '>') + 1))) break;

				// Check for an unclosed tag (ie '<b' or '<li')  Also catches some less thans.
				if (strrpos($current, "<") != 0)
				{
					$current = substr($current, 0, strpos(substr($current, 1), '<') + 1);
					if (" " != $current[1])
					{
						$current = explode("<", $current);
						$current = implode("< ", $current);
					}

					if ("false" != trim($this->options['convert_less_thans'])) $current = str_replace("<", "&lt;", $current);
					else $this->unfixed[] = "A possible unclosed tag has been found.  If you want a less than sign (&lt;), you should use &amp;lt; instead.";

					if (" " != $parsed[strlen($parsed) - 1]) $parsed .= " ";
					$unparsed = substr($unparsed, strpos(substr($unparsed, 1), '<') + 1);
					continue;
				}

				// Check for a less than sign.
				if ('<' == $current)
				{
					$unparsed = substr($unparsed, 1);
					$less_than = true;

					if ("false" != trim($this->options['convert_less_thans'])) $current = "&lt;";
					else $this->unfixed[] = "A possible unclosed tag has been found.  If you want a less than sign (&lt;), you should use &amp;lt; instead.";

					if (" " != $parsed[strlen($parsed) - 1]) $parsed .= " ";
					continue;
				}
				
				// Final check for bastard less-thans or messed up tags.
				if (" " == $current[1])
				{			
					if ("false" != trim($this->options['convert_less_thans'])) $current = str_replace("<", "&lt;", $current);
					else $this->unfixed[] = "A possible unclosed tag has been found.  If you want a less than sign (&lt;), you should use &amp;lt; instead.";
									
					$unparsed = substr($unparsed, strpos($unparsed, '>') + 1);
					if ("false" != trim($this->options['convert_less_thans'])) $current = str_replace(">", "&gt;", $current);
					continue;
				}

				// Make the current tag lower case, and get attributes at the same time.
				$current = explode(" ", $current, 2);
				$current[0] = strtolower($current[0]);
				$attributes = @substr($current[1], 0, -1);
				$current = trim(implode(" ", $current));

				// Get the next tag contents.
				$tag = substr($current, 1, strpos($current,">") - 1);

				// Check to see if it is a comment.
				if ("!--" != substr($tag, 0, 3))
				{
					// First, deal with empty tags

					// Get just the first word in the tag.
					$nl = strpos($tag, 13);
					if ($nl === false) $nl = 1000;
					$sp = strpos($tag, " ");
					if ($sp === false) $sp = 999;

					if ($nl < $sp) $tag = trim(str_replace(strchr($tag, 13), "", $tag));
					else $tag = trim(str_replace(strchr($tag, " "), "", $tag));
									
					if (substr($tag, -1) == "/")
					{
						// Self-closing tag without a space.
						$tag = substr($tag, 0, strlen($tag) - 1);
						if ("" != $attributes) $current = "<$tag $attributes>"; else $current = "<$tag>";
					}

					if ($tag[0] == "/" && in_array(substr($tag, 1), $this->el['empty']))
					{
						if ("" == $attributes) $current = "</$tag>";
						else
						{
							$tag = substr($tag, 1);
							$current = "<$tag $attributes>";
						}
					}

					if (in_array($tag, $this->el['empty']))
					{
						// Close the tag if it's not been self-closed already.
						if (substr($attributes, -1) != "/") $attributes .= " /";
						$current = "<$tag $attributes>";
					}
					elseif (substr($attributes, -1) == "/")
					{
						// User mistakenly closed a non-empty tag.
						$attributes = substr($attributes, 0, strlen($attributes) - 1);
	
						if ("" != $attributes) $current = "<$tag $attributes>"; else $current = "<$tag>";
					}
					
					// Check if it's an opening or closing.
					if ($tag[0] == "/")
					{
						// Remove the "/";
						$tag = substr($tag, 1);

						// Check for an orphaned closing tag.
						$processed = true;
						foreach ($this->tags as $temptag)
						{
							if ($temptag == $tag)
							{
								$processed = false;
								break;
							}
						}
						
						if (!$processed)
						{
							// Pop the last entry off the stack.  Don't worry if it's none existent, as we check next...
							$removed = @array_pop($this->tags);

							if ($tag != $removed)
							{
								$parsed .= "</$removed>";

								while ($removed = @array_pop($this->tags))
								{
									if ($tag == $removed) break;
									else $parsed .= "</$removed>";
								}
							}
						}
					}
					else
					{
						// It's an opening tag.

						// Check the attributes for the given tag, and modify if necessary.
						if ("" != $attributes) $current = $this->check_attributes($tag, $attributes);

						// Check it's valid for comments if necessary
						if ($this->comment && !in_array($tag, $this->el['comments']))
						{
							if ("false" == trim($this->options['auto_inv_comm'])) $this->unfixed[] = "&lt;$tag&gt; is not a valid tag inside a comment.";
							else $processed = true;
						}

						if (!$processed)
						{
							$invalid_position = $this->check_validity($tag);

							if (-5 != $invalid_position)
							{
								if (-1 != $invalid_position)
								{
									if (!in_array($tag, $this->el['empty']))
									{
										if ((($this->tags[$invalid_position - 1] == "ul") || ($this->tags[$invalid_position - 1] == "ol")) && $tag != "li")
										{
											// Special case for lists, which we can automatically wrap.
											if ("false" != trim($this->options['auto_wrap_lists']))
											{
												$parsed .= "<li>";
												array_push($this->tags, "li");
											}
											else $this->unfixed[] = "Only list element &lt;li&gt; tags may be inside a list, but a &lt;$tag&gt; tag has been found.";
										}
										else
										{
											$z = 0;
											while (count($this->tags) >= $invalid_position)
											{
												$z++; if ($z == 25) break;

												if ((count($this->tags) == $invalid_position) && ($this->tags[count($this->tags) - 1] == $tag) && (!in_array($tag, $this->el['siblings']))) $processed = true;
												$removed = @array_pop($this->tags);
												if (!$processed) $parsed .= "</$removed>";
											}
										}
									}
								}
								if (!in_array($tag, $this->el['empty'])) array_push($this->tags, $tag);
							}
							else $processed = true;
						}
					}
				}
				// Set the parser to point to directly after the last tag.
				$unparsed = substr($unparsed, strpos($unparsed,">") + 1);
			}
			// Write in any remaining text and closing tags.
			$parsed .= $unparsed;
			while ($removed = @array_pop($this->tags)) $parsed .= "</$removed>";

			// Remove empty tags if the user wants.
			if ("false" != trim($this->options['auto_remove_empty'])) $parsed = $this->remove_empty_tags($parsed);
			
			if (count($this->unfixed)) $this->verbose = true;
					
			if ($this->verbose)
			{
				if ($this->comment)
				{
					if ("true" == trim($this->options['email_author']))
					{
						global $wpdb;
					
						// Mail the user with a list of the problems.
						$commentdata = $wpdb->get_row("SELECT comment_author, comment_author_email, comment_author_url, comment_post_ID, comment_date FROM $wpdb->comments WHERE comment_ID = '$this->comment'");
						$post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE ID='$commentdata->comment_post_ID' LIMIT 1");
						$user = $wpdb->get_row("SELECT * FROM $wpdb->users WHERE ID='$post->post_author' LIMIT 1");
						$blogname = stripslashes(get_settings('blogname'));
						
						if ('' != $user->user_email)
						{
							if ('' == $commentdata->comment_author_email || '' == $commentdata->comment_author) $from = "From: \"$blogname\" <wordpress@" . $_SERVER['SERVER_NAME'] . '>';
							else $from = 'From: "' . stripslashes($commentdata->comment_author) . "\" <$commentdata->comment_author_email>";
							$url = $wpdb->get_var("SELECT option_value FROM $wpdb->options WHERE option_name = 'siteurl'");
							$url .= "/wp-admin/post.php?action=editcomment&comment=$this->comment";					
							$text = "Hi, this is X-Valid $this->version.  I've just processed a comment posted on your site and attempted to convert it to valid XHTML.  Unfortunately, there were some mistakes I couldn't fix without deleting data or adding something I couldn't guess.  Take a look below to see what changes should be made to the comment to ensure validity...\n\n";
							$text .= "\nComment Details:\n\nComment Author: $commentdata->comment_author\nAuthor Email: $commentdata->comment_author_email\nAuthor URL: $commentdata->comment_author_url\n\n";				
							$f = 1;
							foreach ($this->unfixed as $caveat) $text .= $f++ . ":\t$caveat\n";
							$text .= "\nHave a link to the comment so you can make the changes now...\n$url";	
							$message_headers = "MIME-Version: 1.0\r\n" . "$from\r\n" . "Content-Type: text/plain; charset=\"" . get_settings('blog_charset') . "\"\r\n";
							@mail($user->user_email, "X-Valid $this->version Comment Report", $text, $message_headers);
						}
					}
				}
				elseif ($o = @fopen(ABSPATH . XVALID_DIR . XVALID_OUT, "w"))
				{ 
					global $wpdb;
					
					$post_title = $wpdb->get_var("SELECT post_title FROM $wpdb->posts WHERE ID='$this->post_id' LIMIT 1");
					if ("" != $post_title) $post_title = ", \"<em>$post_title</em>\",";
					$doctype_description = $this->doctypes[$this->options['doctype']];
					fwrite($o, "<html><head><title>X-Validation Results</title><meta http-equiv=\"Content-Type\" content=\"; charset=utf-8\" /><link rel=\"stylesheet\" href=\"" . get_settings('home') . "/wp-admin/wp-admin.css\" type=\"text/css\" /></head>");
					fwrite($o, "<body><div id=\"wphead\"><h1><div style=\"color: #003399; display: inline;\">X</div>-Valid $this->version for <div style=\"color: #003399;display: inline;\">Word</div>Press</h1></div><div class=\"wrap\"><p>Hi!  The post you just edited$post_title was checked and automatically converted to valid (hopefully) $doctype_description markup by <a href=\"http://jamietalbot.com/wp-hacks/\">X-Valid</a>.</p>");
					if (count($this->unfixed)) fwrite($o, "<p>However, there was at least one mistake that I didn't want to correct automatically, as it would involve deleting data or adding something I can't guess.  Take a look below to see what you need to alter for full compliance...</p>");
					fwrite($o, "<p>If you think there are any mistakes in the conversion, please <a href=\"http://jamietalbot.com/about/#contactme\">contact me</a>, including the both the input and output.  This feedback page does have its own limitations, so please be sure to check the post content itself before submitting.  Thanks!</p>");
					fwrite($o, "<p>You can change X-Valid's settings <a href=\""  . get_settings('home') . "/wp-admin/admin.php?page=xvalid.php\">here</a>.</p></div>");

					if (("true" == $this->options['update_check']) && ($version = file_get_contents("http://jamietalbot.com/wp-hacks/xvalid/version-" . substr($wp_version, 0, 3) . ".txt")) && ($version > $this->version)) fwrite($o, "<div class=\"wrap\"><h2>Update Available</h2><p>You are currently using X-Valid version $this->version.  The good news is that a newer version, $version is now available!  If you can be bothered, come and get it <a href=\"http://jamietalbot.com/wp-hacks/\" title=\"X-Valid Update Available\" target=\"_blank\">here</a>!</p></div>");

					fwrite($o, "<div class=\"wrap\"><h2>Input</h2><p><xmp>" . $this->print_tree($old_unparsed) . "</xmp></p></div>");
					fwrite($o, "<div class=\"wrap\"><h2>Output</h2><p><xmp>" . $this->print_tree($parsed) . "</xmp></p></div>");
					fwrite($o, "<div class=\"wrap\"><h2>Visible Output</h2><p>$parsed</p></div>");
					if (count($this->unfixed))
					{
						fwrite($o, "<div class=\"wrap\"><h2>Caveats</h2><ul>");
						foreach ($this->unfixed as $caveat) fwrite($o, "<li>$caveat</li>");
						fwrite($o, "</ul></div>");
					}
					// Include a line to unlink the file once it is read.
					fwrite($o, "<div class=\"wrap\">Copyright &copy; 2004-2005, <a href=\"http://jamietalbot.com\">Jamie Talbot</a>.<br />Licensed under the <a href=\"http://www.opensource.org/licenses/mit-license.php\">MIT License</a>.</div><br /></body></html><?php unlink(\"./xv_output.php\");" . chr(ord("?")) . chr(ord(">")));
					fclose($o);
				}
			}
			return $parsed;
		}
	}
	
	function xvalid_post($id)
	{
		global $wpdb;
		
		if(!isset($id)) $id = $_REQUEST['post_ID'];
		
		// No checking if the user doesn't want it.
		if (isset($_POST['xv_nodocs']) || $_POST['xv_nocheck']) return $id;
	
		$xvalid = new XValidator($_POST['xv_verbose'], $id);
		$content = $wpdb->get_var("SELECT post_content FROM {$wpdb->posts} WHERE ID = '{$id}' LIMIT 1");
		$content = addslashes($xvalid->validate($content));
		
		$wpdb->query("UPDATE {$wpdb->posts} SET post_content = '{$content}' WHERE ID = '{$id}'");
		return $id;
	}

	function xvalid_comment($id)
	{
		global $wpdb;
		
		if(!isset($id)) $id = $_REQUEST['comment_ID'];
	
		$xvalid = new XValidator(false, 0, false, $id);
		
		// No checking if there are no doctypes.
		if (!$xvalid->doctype_count) return $id;
		
		$content = $wpdb->get_var("SELECT comment_content FROM {$wpdb->comments} WHERE comment_ID = '{$id}' LIMIT 1");
		$content = addslashes($xvalid->validate($content));
		
		$wpdb->query("UPDATE {$wpdb->comments} SET comment_content = '{$content}' WHERE comment_ID = '{$id}'");
		return $id;
	}
	
	function xvalid_setup() 
	{
		add_submenu_page('plugins.php', 'X-Valid', 'X-Valid', 5, 'xvalid.php');
		if (file_exists(ABSPATH . XVALID_DIR . XVALID_OUT)) echo "<script language=\"JavaScript\" type=\"text/javascript\">window.open('" . get_settings('home') . '/' . XVALID_DIR . XVALID_OUT . "','_blank','width=600,height=600,resizable=0,scrollbars=yes');</script>";
	}
  
	function xvalid_admin($ignored)
	{
			$v = new XValidator();
		?>	
			<fieldset class="dbx-box" id="xvoptionsdiv" style="margin-top: 10px;">
			<h3 class="dbx-handle">X-Valid <?php echo $v->version ?></h3>	
			<div class="dbx-content">
			<p>
		<?php
			if ($v->doctype_count)
			{
		?>
			<label style="float: right;"><input type="checkbox" name="xv_nocheck" onchange="if(this.checked){document.getElementById('xv_feedback').style.display = 'none';}else{document.getElementById('xv_feedback').style.display = 'block';}" /> Don't Check This Post</label>
			<em>This text will be processed against the <strong><?php echo $v->doctypes[$v->options['doctype']] ?></strong> doctype.</em><br /><span style="margin: 2px 0 10px" id="xv_feedback">
		<?php	if (is_writable(ABSPATH . XVALID_DIR)) 
				{ 
		?>			<label style="float: right;"><input type="checkbox" name="xv_verbose"<?php if ("true" == $v->options['show_output']) echo " checked=\"checked\""; ?> /> Show Results</label>
		<?php	}
				else
				{
		?>			<em>Feedback is not available because your <a href="<?php echo get_settings('home') . '/' . XVALID_DIR . '' ?>">X-Valid directory</a> is not writable!</em>
		<?php	} ?></span><?php
			}
			else
			{
		?>
			<strong>Warning: X-Valid could not find any doctypes to validate against.  No processing will take place.</strong>
			<input type="hidden" name="xv_nodocs" value="true" />
		<?php
			}
		?>
			</p>
		<?php
	?>		</div></fieldset>
	<?php
	}
}

// Runs the function to add the menu and popup results window if necessary.
add_action('admin_menu', 'xvalid_setup');

?>